## emacs 26.1.3

=== test/lisp/progmodes/flymake-resources/Makefile ===
# Makefile for flymake tests

CC_OPTS = -Wall -Wextra

## Recent gcc (e.g. 4.8.2 on RHEL7) can automatically colorize their output,
## which can confuse flymake.  Set GCC_COLORS to disable that.
## This only seems to be an issue in batch mode, where you would not
## normally use flymake, so it seems like just avoiding the issue
## in this test is fine.  Set flymake-log-level to 3 to investigate.
check-syntax:
	GCC_COLORS= $(CC) $(CC_OPTS) ${CHK_SOURCES} || true

# eof

## emacs 25.2+1

=== debian/changelog ===
emacs (1:25.2+1-11) unstable; urgency=medium

  * Add (>= 1:25) restriction to emacs metapackage dependencies.
    Without this it was possible to end up with two empty metapackages
    installed instead of the expected metapackage and actual package.
    Thanks to Shin Yoshida for reporting the problem and Sven Joachim
    for noting the solution. (Closes: 906534)

  * Don't unexpectedly modify the byte order mark.  Add
    0014-Emacs-should-no-longer-unexpectedly-alter-the-byte-o.patch to
    fix the problem.  Thanks to Vincent Lefevre for reporting the
    problem and Eli Zaretskii for the patch. (Closes: 883434)

 -- Rob Browning <rlb@defaultvalue.org>  Sun, 26 Aug 2018 11:49:09 -0500

emacs (1:25.2+1-10) unstable; urgency=medium

  * Handle the emacs-{gtk,lucid,nox} doc dir transition manually.
    Before the unversioning, these packages were in a different source
    package (emacs-defaults) and were arch all.  Since
    dpkg-mainscript-helper can't hande "all to any" transitions
    (https://bugs.debian.org/cgi-bin/bugreport.cgi?bug=813455), clean
    up manually in the preinsts.  Thanks to Sven Joachim for reporting
    the problem and indentifying the underlying cause.
    (Closes: 905555)

 -- Rob Browning <rlb@defaultvalue.org>  Sun, 12 Aug 2018 11:55:27 -0500

emacs (1:25.2+1-9) unstable; urgency=medium

  * Disable the eieio-test-37-obsolete-name-in-constructor test.  Its
    behavior is unpredictable, and it was causing some buildd builds
    to fail (cf. https://debbugs.gnu.org/24503).  Add
    0013-Disable-eieio-test-37-obsolete-name-in-constructor.patch to
    fix the problem, and thanks to Aaron M. Ucko for reporting it, and
    J. Smith for tracking down the upstream issue. (Closes: 879020)

  * Ensure /usr/share/doc/emacs-{gtk,lucid,nox} symlink is
    established.  Use dir_to_symlink to make sure the new symlink to
    emacs-common is correctly established if we're upgrading from the
    emacs-defaults packages that had a real directory.  Thanks to
    Andreas Beckmann for reporting the problem. (Closes: 903779)

  * Have emacs-{gtk,lucid,nox} replace all the related emacs25
    packages.  Add "emacs-gtk (<< 1:25), emacs-lucid (<< 1:25),
    emacs-nox (<< 1:25)" to the "Replaces:" for emacs-gtk,
    emacs-lucid, and emacs-nox to avoid conflicts over
    /usr/share/emacs/25.2/etc/DOC while unpacking.  Thanks to Axel
    Beckert for reporting the problem and Adrian Bunk and Sven Joachim
    for help with the solution. (Closes: 904957)

 -- Rob Browning <rlb@defaultvalue.org>  Sat, 04 Aug 2018 12:29:53 -0500

emacs (1:25.2+1-8) unstable; urgency=medium

  * Move unversioned emacs packages from experimental to unstable.

 -- Rob Browning <rlb@defaultvalue.org>  Sun, 29 Jul 2018 10:46:26 -0500

emacs (1:25.2+1-7) experimental; urgency=medium

  * Unversion the emacs packages.  Remove the major version from all
    of the packages.  The flexibility provided no longer appears worth
    the complexity given the more frequent upstream releases, and
    backward-compatability across them.

  * Update debian/patches for emacs25 to emacs migration.

  * Rename emacsXY to emacsXY-gtk.

  * Fix dbg package self-dependencies.

  * Stop versioning packages; change emacs25 to emacs.

  * Move mail-host-address and gnus-nntpserver-file to new
    00debian.el.

  * Move emacs binary metapackage to this package.  Add epoch so that
    new versions of the metapackage will be higher than the last
    standalone version (47.0).

  * Handle local emacs/site-lisp here instead of in emacsen-common.

  * Depend on emacsen-common (>= 3.0.0) This will complete the
    transfer of the emacs metapackage namespace to the emacs source
    package as a new concrete emacs flavor.

  * Add emacs23, emacs24, and emacs25 transitional packages.

  * debian/control: change priority extra to optional as per policy.

  * Have binary flavor packages depend on emacs-common for doc
    symlink.

 -- Rob Browning <rlb@defaultvalue.org>  Sun, 27 May 2018 10:57:34 -0500

emacs25 (25.2+1-6) unstable; urgency=high

  * Block remote code execution via enriched text.  Add
    0012-A-remote-execution-exploit-via-enriched-text-has-bee.patch to
    fix the problem.  Thanks to David Bremner for the alert and
    Salvatore Bonaccorso for reporting the problem to Debian.
    (Closes: 875447)

 -- Rob Browning <rlb@defaultvalue.org>  Mon, 11 Sep 2017 21:51:49 -0500

emacs25 (25.2+1-5) unstable; urgency=medium

  * Build with -O0 on arm64 to avoid FTBS.  Without this the build
    segfaults in marker.c when trying to construct c-by.el.
    cf. https://lists.gnu.org/archive/html/emacs-devel/2017-03/msg00798.html
    Thanks to Gianfranco Costamagna for reporting the bug and Barry
    Warsaw for suggesting the workaround. (Closes: 868165)

 -- Rob Browning <rlb@defaultvalue.org>  Mon, 31 Jul 2017 23:34:05 -0500

emacs25 (25.2+1-4) unstable; urgency=medium

  * Disable eieio-test-method-order-list-6.  Its behavior is
    unpredictable, and it was causing the armhf build to fail:
      https://debbugs.gnu.org/27878
      https://debbugs.gnu.org/24503#21
    Add 0011-Disable-eieio-test-method-order-list-6.patch to fix the
    problem.  Thanks to Glen Morris for pointing out the previous report.

 -- Rob Browning <rlb@defaultvalue.org>  Sun, 30 Jul 2017 22:31:30 -0500

emacs25 (25.2+1-3) unstable; urgency=medium

  * Actually run tests by default (fix DEB_BUILD_OPTIONS nocheck test)
    Fix the inverted logic.  Thanks to John Paul Adrian Glaubitz for
    reporting the problem.  (Closes: 869328)

  * Completely remove gconf support.  Build --without-gconf for the
    emacs25 flavor (as we already do for lucid and nox), since GConf
    has been deprecated for years.  Thanks to intrigeri for reporting
    the issue. (Closes: 869085)

  * Fix README.Debian news entry for
    0008-Don-t-provide-openssl-s_client-as-an-option-for-ssl-.patch.

  * Fix memory alignment problem causing FTBS on m68k.  Thanks to John


=== debian/control ===
Source: emacs
Section: editors
Priority: optional
Maintainer: Rob Browning <rlb@defaultvalue.org>
Build-Depends: bsd-mailx | mailx, libncurses5-dev, texinfo, liblockfile-dev, librsvg2-dev,
 dbus-x11,
 gnupg-agent,
 libgif-dev | libungif4-dev,
 libtiff-dev,
 procps,
 xaw3dg-dev,
 libpng-dev, libjpeg-dev, libm17n-dev, libotf-dev,
 libgpm-dev [linux-any], libdbus-1-dev,
 autoconf, automake, autotools-dev, dpkg-dev (>> 1.10.0), quilt (>= 0.42),
 debhelper (>= 9), libxaw7-dev, sharutils, imagemagick, libgtk-3-dev,
 libgnutls28-dev, libxml2-dev, libselinux1-dev [linux-any],
 libasound2-dev [!hurd-i386 !kfreebsd-i386 !kfreebsd-amd64],
 libmagick++-6.q16-dev,
 libacl1-dev,
 liboss4-salsa-dev [hurd-i386 kfreebsd-i386 kfreebsd-amd64],
 zlib1g-dev
Homepage: http://www.gnu.org/software/emacs/
Standards-Version: 3.7.2

Package: emacs
Architecture: all
Depends:
  emacs-gtk (>= 1:25) | emacs-lucid (>= 1:25) | emacs-nox (>= 1:25),
  ${misc:Depends}
Description: GNU Emacs editor (metapackage)
 GNU Emacs is the extensible self-documenting text editor.
 This is a metapackage that will always depend on the latest
 recommended Emacs variant (currently emacs-gtk).

Package: emacs-lucid
Architecture: any
Depends:
  emacs-bin-common (= ${binary:Version}),
  emacs-common (= ${source:Version}),
  ${shlibs:Depends}, ${misc:Depends}
Provides: emacs, emacsen, editor, info-browser, mail-reader, news-reader
Suggests: emacs-common-non-dfsg
Conflicts: emacs-gtk, emacs-nox
Replaces: emacs-gtk, emacs-nox,
  emacs-gtk (<< 1:25), emacs-lucid (<< 1:25), emacs-nox (<< 1:25)
Description: GNU Emacs editor (with Lucid GUI support)
 GNU Emacs is the extensible self-documenting text editor.  This
 package contains a version of Emacs with support for a graphical user
 interface based on the Lucid toolkit (instead of the GTK+ interface
 provided by the emacs-gtk package).  Until some known GTK+
 problems are fixed, this version may help avoid crashing Emacs during
 an emacsclient disconnect.  See
 https://bugs.debian.org/cgi-bin/bugreport.cgi?bug=567934 and
 https://bugzilla.gnome.org/show_bug.cgi?id=85715 for more
 information.

Package: emacs-lucid-dbg
Section: debug
Priority: optional
Architecture: any
Depends: emacs-lucid (= ${binary:Version}), ${misc:Depends}
Description: Debugging symbols for emacs-lucid
 GNU Emacs is the extensible self-documenting text editor.  This
 package contains the debugging symbols for the emacs-lucid
 package.

Package: emacs-nox
Architecture: any
Depends:
  emacs-bin-common (= ${binary:Version}),
  emacs-common (= ${source:Version}),
  ${shlibs:Depends}, ${misc:Depends}
Provides: emacs, emacsen, editor, info-browser, mail-reader, news-reader
Suggests: emacs-common-non-dfsg
Conflicts: emacs-gtk, emacs-lucid
Replaces: emacs-gtk, emacs-lucid,
  emacs-gtk (<< 1:25), emacs-lucid (<< 1:25), emacs-nox (<< 1:25)
Description: GNU Emacs editor (without GUI support)
 GNU Emacs is the extensible self-documenting text editor.  This
 package contains a version of Emacs compiled without support for X,
 and provides only a text terminal interface.

Package: emacs-nox-dbg
Section: debug
Priority: optional
Architecture: any
Depends: emacs-nox (= ${binary:Version}), ${misc:Depends}
Description: Debugging symbols for emacs-nox
 GNU Emacs is the extensible self-documenting text editor.  This
 package contains the debugging symbols for the emacs-nox
 package.

Package: emacs-gtk
Architecture: any
Depends:
  emacs-bin-common (= ${binary:Version}),
  emacs-common (= ${source:Version}),
  ${shlibs:Depends}, ${misc:Depends}
Provides: emacs, emacsen, editor, info-browser, mail-reader, news-reader
Suggests: emacs-common-non-dfsg
Conflicts: emacs-lucid, emacs-nox
Replaces: emacs-lucid, emacs-nox,
  emacs-gtk (<< 1:25), emacs-lucid (<< 1:25), emacs-nox (<< 1:25)
Description: GNU Emacs editor (with GTK+ GUI support)
 GNU Emacs is the extensible self-documenting text editor.  This
 package contains a version of Emacs with a graphical user interface
 based on GTK+ (instead of the Lucid toolkit provided by the
 emacs-lucid package).

Package: emacs-gtk-dbg
Section: debug
Priority: optional
Architecture: any
Depends: emacs-gtk (= ${binary:Version}), ${misc:Depends}
Description: Debugging symbols for emacs-gtk
 GNU Emacs is the extensible self-documenting text editor.  This
 package contains the debugging symbols for the emacs-gtk package.

Package: emacs-bin-common
Architecture: any
Depends: emacs-common (= ${source:Version}), ${shlibs:Depends}, ${misc:Depends}
Description: GNU Emacs editor's shared, architecture dependent files
 GNU Emacs is the extensible self-documenting text editor.
 This package contains the architecture dependent infrastructure
 that's shared by emacs-gtk, emacs-lucid, and emacs-nox.

Package: emacs-common
Architecture: all
Depends: emacsen-common (>= 3.0.0), install-info, ${shlibs:Depends}, ${misc:Depends}
Recommends: emacs-el
Suggests: emacs-el, emacs-common-non-dfsg, ncurses-term
Conflicts: emacs-el (<< ${source:Version}), cedet, eieio, speedbar, gnus-bonus-el
Breaks: apel (<< 10.8+0.20120427-4)
Description: GNU Emacs editor's shared, architecture independent infrastructure
 GNU Emacs is the extensible self-documenting text editor.
 This package contains the architecture independent infrastructure
 that's shared by emacs-gtk, emacs-lucid, and emacs-nox.

Package: emacs-el
Architecture: all
Depends: emacs-common (= ${source:Version}), ${misc:Depends}
Description: GNU Emacs LISP (.el) files
 GNU Emacs is the extensible self-documenting text editor.
 This package contains the elisp sources for the convenience of users,
 saving space in the main package for small systems.

Package: emacs23
Section: oldlibs
Priority: optional
Architecture: all
Depends: emacs-gtk (>= 1:25)
Description: GNU Emacs transitional package to emacs-gtk
 GNU Emacs is the extensible self-documenting text editor.  This
 package is a transitional package to ensure that systems with emacs23
 installed automatically upgrade to the new unversioned emacs-gtk
 package.

Package: emacs23-lucid
Section: oldlibs
Priority: optional
Architecture: all
Depends: emacs-lucid (>= 1:25)
Description: GNU Emacs transitional package to emacs-lucid
 GNU Emacs is the extensible self-documenting text editor.  This
 package is a transitional package to ensure that systems with emacs23
 installed automatically upgrade to the new unversioned emacs-lucid
 package.

Package: emacs23-nox
Section: oldlibs
Priority: optional
Architecture: all
Depends: emacs-nox (>= 1:25)
Description: GNU Emacs transitional package to emacs-nox
 GNU Emacs is the extensible self-documenting text editor.  This
 package is a transitional package to ensure that systems with emacs23
 installed automatically upgrade to the new unversioned emacs-nox
 package.

Package: emacs24
Section: oldlibs
Priority: optional
Architecture: all
Depends: emacs-gtk (>= 1:25)
Description: GNU Emacs transitional package to emacs-gtk
 GNU Emacs is the extensible self-documenting text editor.  This
 package is a transitional package to ensure that systems with emacs24
 installed automatically upgrade to the new unversioned emacs-gtk
 package.

Package: emacs24-lucid
Section: oldlibs
Priority: optional
Architecture: all
Depends: emacs-lucid (>= 1:25)
Description: GNU Emacs transitional package to emacs-lucid
 GNU Emacs is the extensible self-documenting text editor.  This
 package is a transitional package to ensure that systems with emacs24
 installed automatically upgrade to the new unversioned emacs-lucid
 package.

Package: emacs24-nox
Section: oldlibs
Priority: optional
Architecture: all
Depends: emacs-nox (>= 1:25)
Description: GNU Emacs transitional package to emacs-nox
 GNU Emacs is the extensible self-documenting text editor.  This
 package is a transitional package to ensure that systems with emacs24
 installed automatically upgrade to the new unversioned emacs-nox
 package.

Package: emacs25
Section: oldlibs
Priority: optional
Architecture: all
Depends: emacs-gtk (>= 1:25)
Description: GNU Emacs transitional package to emacs-gtk
 GNU Emacs is the extensible self-documenting text editor.  This
 package is a transitional package to ensure that systems with emacs25
 installed automatically upgrade to the new unversioned emacs-gtk
 package.

Package: emacs25-lucid
Section: oldlibs
Priority: optional
Architecture: all
Depends: emacs-lucid (>= 1:25)
Description: GNU Emacs transitional package to emacs-lucid
 GNU Emacs is the extensible self-documenting text editor.  This
 package is a transitional package to ensure that systems with emacs25
 installed automatically upgrade to the new unversioned emacs-lucid
 package.

Package: emacs25-nox
Section: oldlibs
Priority: optional
Architecture: all
Depends: emacs-nox (>= 1:25)
Description: GNU Emacs transitional package to emacs-nox
 GNU Emacs is the extensible self-documenting text editor.  This
 package is a transitional package to ensure that systems with emacs25
 installed automatically upgrade to the new unversioned emacs-nox
 package.

=== debian/rules ===
#!/usr/bin/make -f
# -*- makefile -*-

# This file is licensed under the terms of the Gnu Public License.
# With the one additional provision that Ian Jackson's name may not be
# removed from the file.

# Copyright 1994,1995 Ian Jackson
# Copyright 2004-2005 Jrme Marant <jerome@debian.org>
# Copyright 1998-2017 Rob Browning <rlb@defaultvalue.org>

# Originally copied from the GNU Hello Debian rules file (1.3).
# Modified for emacs by Mark Eichin <eichin@kitten.gen.ma.us>.
# Debhelper support added via one of Joey Hess' example files.
# See the debian/changelog for further historical information.

# Uncomment this to turn on verbose mode.
#export DH_VERBOSE=1

SHELL := /bin/bash
quilt := QUILT_PATCHES=debian/patches QUILT_PATCHES_PREFIX=y quilt
pf := set -o pipefail

# This package uses debian/source/format 3.0 (quilt).

# For now we assume that emacs' versioning scheme is always
# MAJOR.MINORtinyrev where MAJOR and MINOR are integers and tinyrev is
# an optional lowercase letter (or letters).  We also assume that
# upstream uses a numbering scheme that sorts in a "Debian friendly"
# way.  So far that's always been true.  If it becomes false, some of
# the values below will have to be set manually.

# (You might imagine that a VPATH build would allow us to avoid having
#  to copy the entire source tree for each of the three builds, but it
#  turns out that the emacs build process doesn't entirely respect the
#  VPATH and modifies all kinds of files in the srcdir (e.g. *.elc,
#  *.map, etc.).

# The official upstream version defined by AC_INIT in configure.in.
upstream_ver := $(shell debian/upstream-version)
ifeq (,$(upstream_ver))
  $(error 'Unable to find upstream version number.')
endif

# This must be the version that's actually used at runtime for things
# like load-path.  It may not be the same as the upstream version
# (i.e. when you have upstream 20.5a, the functional version may still
# be 20.5), so sometimes we may have to do this by hand.
runtime_ver := $(shell $(pf); echo $(upstream_ver) | perl -pe 's/[a-z]+$$//o')
major_ver := $(shell $(pf); echo $(runtime_ver) | perl -pe 's/\..*$$//o')
minor_ver := $(shell $(pf); echo $(runtime_ver) | perl -pe 's/^[^.]*\.//o')

# The name of the Debian source package
src_name := $(shell $(pf); dpkg-parsechangelog | egrep '^Source:')
src_name := $(shell $(pf); echo $(src_name) | perl -pe 's/Source:\s+//o')

# The version from the changelog (i.e. 20.5-1)
debian_ver := $(shell $(pf); dpkg-parsechangelog | egrep '^Version:')
debian_ver := $(shell $(pf); echo $(debian_ver) | perl -pe 's/Version:\s+//o')

# The Debian revision (i.e. the 1 from 20.5-1)
# Always everything after the last '-'
debian_rev := $(shell $(pf); echo $(debian_ver) | perl -pe 's/.*-//o')

# Might be 21.3, or it might be 21.3+1 if we've had to have more than
# one re-release of the upstream source (rare, but it happens), or if
# we have to split the package for DFSG purposes.  Always everything
# before the last '-'
debsrc_ver := $(shell $(pf); echo $(debian_ver) | perl -pe 's/-[^-]+$$//o')

######################################################################
# Customizable variables

bin_priority := 28

# This might also be something like 2006-09-09 for snapshots.
menu_ver := $(major_ver)

######################################################################

# Should these be exported like this (as autotools-dev recommends for
# the two vars below) or not?
export DEB_HOST_ARCH ?= $(shell dpkg-architecture -qDEB_HOST_ARCH)
export DEB_HOST_GNU_CPU ?= $(shell dpkg-architecture -qDEB_HOST_GNU_CPU)

# As recommended by /usr/share/doc/autotools-dev/README.Debian.gz.
# Handle cross-compiling and don't make ./configure guess.
export DEB_HOST_GNU_TYPE ?= $(shell dpkg-architecture -qDEB_HOST_GNU_TYPE)
export DEB_BUILD_GNU_TYPE ?= $(shell dpkg-architecture -qDEB_BUILD_GNU_TYPE)

# FOR AUTOCONF 2.52 AND NEWER ONLY
ifeq ($(DEB_BUILD_GNU_TYPE), $(DEB_HOST_GNU_TYPE))
  confflags += --build $(DEB_HOST_GNU_TYPE)
else
  confflags += --build $(DEB_BUILD_GNU_TYPE) --host $(DEB_HOST_GNU_TYPE)
endif

deb_host_multiarch := $(shell dpkg-architecture -qDEB_HOST_MULTIARCH)

# Without this, the build dies in marker.c when trying to create c-by.el
ifeq ($(DEB_HOST_ARCH),arm64)
  export DEB_CFLAGS_MAINT_APPEND := -O0
endif

CFLAGS = $(shell dpkg-buildflags --get CFLAGS)
CFLAGS += -Wall
LDFLAGS = $(shell dpkg-buildflags --get LDFLAGS)
CPPFLAGS = $(shell dpkg-buildflags --get CPPFLAGS)

joblimit := $(patsubst parallel=%,%,$(filter parallel=%,$(DEB_BUILD_OPTIONS)))
ifeq (,$(joblimit))
  joblimit := 1
endif

target := $(DEB_HOST_GNU_TYPE)
movemail_bin := usr/lib/emacs/$(runtime_ver)/$(target)/movemail

# Info files that are going to show up in the main dir.
main_dir_info_files := efaq.info

# Files that the build stage depends on (may also be listed in other vars).
persistent_autogen_build_files := debian/copyright
nonpersistent_autogen_build_files :=

# These files must always exist, i.e. can't ever be cleaned.
persistent_autogen_install_files :=

nonpersistent_autogen_install_files := \
  debian/emacs-bin-common.lintian-overrides \
  debian/emacs-bin-common.postinst \
  debian/emacs-bin-common.prerm \
  debian/emacs-common.README.Debian \
  debian/emacs-common.postinst \
  debian/emacs-common.prerm \
  debian/emacs-nox.lintian-overrides \
  debian/emacs-nox.postinst \
  debian/emacs-nox.preinst \
  debian/emacs-nox.prerm \
  debian/emacs-lucid.lintian-overrides \
  debian/emacs-lucid.postinst \
  debian/emacs-lucid.preinst \
  debian/emacs-lucid.prerm \
  debian/emacs-gtk.lintian-overrides \
  debian/emacs-gtk.preinst \
  debian/emacs-gtk.postinst \
  debian/emacs-gtk.prerm

autogen_build_files := \
  $(nonpersistent_autogen_build_files) $(persistent_autogen_build_files)

autogen_install_files := \
  $(nonpersistent_autogen_install_files) $(persistent_autogen_install_files)

persistent_autogen_files := \
  $(persistent_autogen_build_files) $(persistent_autogen_install_files)

nonpersistent_autogen_files := \
  $(nonpersistent_autogen_build_files) $(nonpersistent_autogen_install_files)


# Build directories
pkgdir_common := $(CURDIR)/debian/emacs-common
pkgdir_bin_common := $(CURDIR)/debian/emacs-bin-common
pkgdir_gtk := $(CURDIR)/debian/emacs-gtk
pkgdir_nox := $(CURDIR)/debian/emacs-nox
pkgdir_lucid := $(CURDIR)/debian/emacs-lucid
pkgdir_el := $(CURDIR)/debian/emacs-el

install_dir_gtk := $(CURDIR)/debian/install-gtk
install_dir_nox := $(CURDIR)/debian/install-nox
install_dir_lucid := $(CURDIR)/debian/install-lucid

local_lpath := /etc/emacs
local_lpath := $(local_lpath):/usr/local/share/emacs/$(runtime_ver)/site-lisp
local_lpath := $(local_lpath):/usr/local/share/emacs/site-lisp
local_lpath := $(local_lpath):/usr/share/emacs/$(runtime_ver)/site-lisp
local_lpath := $(local_lpath):/usr/share/emacs/site-lisp

# Installation local_lpath
local_lpath_install \
  := $(pkgdir_common)/$(subst :,:$(pkgdir_common)/,$(local_lpath))

# If we ever need to do the stripping outside of dh_strip, just add an
# INSTALL_STRIP="-s" to the make vars below.

define emacs_inst
  $(MAKE) -C debian/$(1) install \
    DESTDIR=$(2) \
    infodir=/usr/share/info/emacs \
    localstatedir=/var
endef

# If we ever need it, we can create a copy that doesn't assume ./debian/
define deb_sub
  perl -p \
    -e "s|\@PKG_NAME\@|$(pkg_name)|go;" \
    -e "s|\@MAJOR_VERSION\@|$(major_ver)|go;" \
    -e "s|\@MINOR_VERSION\@|$(minor_ver)|go;" \
    -e "s|\@FULL_VERSION\@|$(runtime_ver)|go;" \
    -e "s|\@PACKAGE_VERSION\@|$(debian_ver)|go;" \
    -e "s|\@DEBIAN_REV\@|$(deb_rev)|go;" \
    -e "s|\@UPSTREAM_VERSION\@|$(upstream_ver)|go;" \
    -e "s|\@DEBSRC_VERSION\@|$(debsrc_ver)|go;" \
    -e "s|\@MENU_VERSION\@|$(menu_ver)|go;" \
    -e "s|\@X_SUPPORT\@|$(xsupport)|go;" \
    -e "s|\@BIN_PRIORITY\@|$(bin_priority)|go;" \
    -e "s|\@MOVEMAIL_BIN\@|$(movemail_bin)|go;" \
      < $(1) > $(2)
endef

%:
	dh $@ --parallel

check-vars:
	@echo "src_name: $(src_name)"
	@echo "upstream_ver: $(upstream_ver)"

## emacs 26.1+1

=== debian/changelog ===
emacs (1:26.1+1-4) unstable; urgency=high

  * Update the EPLA packaging key (previous key expires 2019-09-23) via
    the upstream commit f16785d361097df9fddfcc0b60ae6f0d92e7e911.  Add the
    old and new keyrings to debian/ and debian/source/include-binaries
    since debian/patches/ can't handle git binary diffs.  Thanks to Stefan
    Monnier for reporting the problem and providing the patch.

 -- Rob Browning <rlb@defaultvalue.org>  Sun, 08 Sep 2019 15:02:23 -0500

emacs (1:26.1+1-3.3) unstable; urgency=medium

  * Non-maintainer upload.

  * Drop transitional versioned emacsXX* packages.

  * Cherry-pick 408bf21a8c and 95b77b0451 to fix crashes with color fonts,
    thanks to Vincent Lefevre.  (Closes: #929567)

 -- Andreas Beckmann <anbe@debian.org>  Fri, 12 Jul 2019 20:42:27 +0200

emacs (1:26.1+1-3.2) unstable; urgency=medium

  * Non-maintainer upload.

  * Add more transitional packages for ancient versioned packages
    emacs21{,-nox}, emacs22{,-gtk,-nox}.  (Closes: #916758)

  * Drop -dbg packages in favor of autogenerated -dbgsym packages.

 -- Andreas Beckmann <anbe@debian.org>  Sun, 03 Feb 2019 15:42:30 +0100

emacs (1:26.1+1-3.1) unstable; urgency=medium

  * Non-maintainer upload.

  * Really handle the emacs-{gtk,lucid,nox} doc dir transition manually.
    This cannot be handled by 'dpkg-maintscript-helper dir_to_symlink' because
    of the arch:all to arch:any switch at the same time (bug #813455).
    Do not forcibly remove the old docdir in the preinst to avoid bad effects
    on other packages. Instead, in the postinst, replace the now empty
    directory with the intended symlink.  (Closes: #911616)

  * emacs-common: Add Breaks against all (versioned) emacs binary packages
    predating the unversioning in 1:25.

  * emacs-common: Add Breaks against known incompatible packages:
    - edb  (Closes: #875430)
    - egg  (Closes: #910925)

  * Add Vcs-* URLs.  (Closes: #690771)

  * Cherry-pick 34b4da37 to fix a test failure.  (Closes: #918646)

  * Clean-up debian/control.

  * Use https:// URLs and update FSF address.

  * Update Lintian overrides.

 -- Andreas Beckmann <anbe@debian.org>  Mon, 28 Jan 2019 14:18:17 +0100

emacs (1:26.1+1-3) unstable; urgency=medium

  * Recommend mailutils instead of depending on it.
    (Closes: 917245, 916986)

 -- Rob Browning <rlb@defaultvalue.org>  Wed, 26 Dec 2018 13:54:16 -0600

emacs (1:26.1+1-2) unstable; urgency=medium

  * Update emacs metapackage to depend on >= 1:26.1.

  * Enable support for systemd socket activation.  Thanks to Ansgar
    Burchardt for the report. (Closes: 916760)

 -- Rob Browning <rlb@defaultvalue.org>  Thu, 20 Dec 2018 10:49:20 -0600

emacs (1:26.1+1-1) experimental; urgency=medium

  * Merge upstream version 26.1. (Closes: #907997)

  * Update debian/copyright version for 26.1.

  * Use more secure mailutils instead of internal movemail.  See the
    26.1 NEWS for more information.

  * Add debian/copyright entries for 26.1.

  * Fix epg-tests with upstream patch for newer GnuPG.  Add
    0009-An-epg-test-failure-with-recent-GnuPG-versions-has-b.patch to
    fix the problem.

  * Mark the vc-bzr-test-faulty-bzr-autoloads as unstable for now.
    Add 0010-Mark-vc-bzr-test-fauilt-bzr-autoloads-as-unstable-fo.patch to
    disable the test for now.  See the patch header for a description
    of the error.

  * tramp-test42-remote-load-path: regexp-quote directory.  Add
    0011-tramp-test42-remote-load-path-regexp-quote-directory.patch to
    fix the problem.  Otherwise the test may fail for some paths like
    those seen in an sbuild chroot,
    e.g. build/emacs-i87jK3/emacs-26.1+1/...

  * ibuffer-filter-inclusion-3: regexp-quote directory.  Add
    0012-ibuffer-filter-inclusion-3-regexp-quote-directory.patch to
    fix the problem.  Otherwise the test may fail for some paths like
    those seen in an sbuild chroot,
    e.g. build/emacs-i87jK3/emacs-26.1+1/...

  * Mark echo-server-with-dns test as :unstable for now.  It fails
    inside a Debian sbuild chroot.

 -- Rob Browning <rlb@defaultvalue.org>  Mon, 17 Dec 2018 16:41:12 -0600

=== debian/control ===
Source: emacs
Section: editors
Priority: optional
Maintainer: Rob Browning <rlb@defaultvalue.org>
Build-Depends: bsd-mailx | mailx, libncurses5-dev, texinfo, liblockfile-dev, librsvg2-dev,
 dbus-x11,
 gnupg-agent,
 libgif-dev,
 libtiff-dev,
 libsystemd-dev,
 procps,
 xaw3dg-dev,
 libpng-dev, libjpeg-dev, libm17n-dev, libotf-dev,
 libgpm-dev [linux-any], libdbus-1-dev,
 autoconf,
 automake,
 dpkg-dev (>> 1.10.0),
 quilt (>= 0.42),
 debhelper (>= 10),
 libxaw7-dev,
 sharutils,
 imagemagick,
 libgtk-3-dev,
 libgnutls28-dev, libxml2-dev, libselinux1-dev [linux-any],
 libasound2-dev [!hurd-i386 !kfreebsd-i386 !kfreebsd-amd64],
 libmagick++-6.q16-dev,
 libacl1-dev,
 liboss4-salsa-dev [hurd-i386 kfreebsd-i386 kfreebsd-amd64],
 zlib1g-dev
Homepage: https://www.gnu.org/software/emacs/
Standards-Version: 3.7.2
Vcs-Browser: https://salsa.debian.org/rlb/deb-emacs
Vcs-Git: https://salsa.debian.org/rlb/deb-emacs.git

Package: emacs
Architecture: all
Depends:
  emacs-gtk (>= 1:26.1) | emacs-lucid (>= 1:26.1) | emacs-nox (>= 1:26.1),
  ${misc:Depends}
Description: GNU Emacs editor (metapackage)
 GNU Emacs is the extensible self-documenting text editor.
 This is a metapackage that will always depend on the latest
 recommended Emacs variant (currently emacs-gtk).

Package: emacs-lucid
Architecture: any
Depends:
  emacs-bin-common (= ${binary:Version}),
  emacs-common (= ${source:Version}),
  ${shlibs:Depends}, ${misc:Depends}
Provides: emacs, emacsen, editor, info-browser, mail-reader, news-reader
Suggests: emacs-common-non-dfsg
Conflicts: emacs-gtk, emacs-nox
Replaces: emacs-gtk, emacs-nox,
Description: GNU Emacs editor (with Lucid GUI support)
 GNU Emacs is the extensible self-documenting text editor.  This
 package contains a version of Emacs with support for a graphical user
 interface based on the Lucid toolkit (instead of the GTK+ interface
 provided by the emacs-gtk package).  Until some known GTK+
 problems are fixed, this version may help avoid crashing Emacs during
 an emacsclient disconnect.  See
 https://bugs.debian.org/cgi-bin/bugreport.cgi?bug=567934 and
 https://bugzilla.gnome.org/show_bug.cgi?id=85715 for more
 information.

Package: emacs-nox
Architecture: any
Depends:
  emacs-bin-common (= ${binary:Version}),
  emacs-common (= ${source:Version}),
  ${shlibs:Depends}, ${misc:Depends}
Provides: emacs, emacsen, editor, info-browser, mail-reader, news-reader
Suggests: emacs-common-non-dfsg
Conflicts: emacs-gtk, emacs-lucid
Replaces: emacs-gtk, emacs-lucid,
Description: GNU Emacs editor (without GUI support)
 GNU Emacs is the extensible self-documenting text editor.  This
 package contains a version of Emacs compiled without support for X,
 and provides only a text terminal interface.

Package: emacs-gtk
Architecture: any
Depends:
  emacs-bin-common (= ${binary:Version}),
  emacs-common (= ${source:Version}),
  ${shlibs:Depends}, ${misc:Depends}
Provides: emacs, emacsen, editor, info-browser, mail-reader, news-reader
Suggests: emacs-common-non-dfsg
Conflicts: emacs-lucid, emacs-nox
Replaces: emacs-lucid, emacs-nox,
Description: GNU Emacs editor (with GTK+ GUI support)
 GNU Emacs is the extensible self-documenting text editor.  This
 package contains a version of Emacs with a graphical user interface
 based on GTK+ (instead of the Lucid toolkit provided by the
 emacs-lucid package).

Package: emacs-bin-common
Architecture: any
Depends: emacs-common (= ${source:Version}), ${shlibs:Depends}, ${misc:Depends}
Recommends: mailutils
Description: GNU Emacs editor's shared, architecture dependent files
 GNU Emacs is the extensible self-documenting text editor.
 This package contains the architecture dependent infrastructure
 that's shared by emacs-gtk, emacs-lucid, and emacs-nox.

Package: emacs-common
Architecture: all
Depends: emacsen-common (>= 3.0.0), install-info, ${misc:Depends}
Recommends: emacs-el
Suggests: emacs-common-non-dfsg, ncurses-term
Conflicts: emacs-el (<< ${source:Version}), cedet, eieio, speedbar, gnus-bonus-el
Breaks:
 emacs (<< 1:25),
 emacs-gtk (<< 1:25),
 emacs-lucid (<< 1:25),
 emacs-nox (<< 1:25),
 emacs21,
 emacs21-nox,
 emacs22,
 emacs22-gtk,
 emacs22-nox,
 emacs23,
 emacs23-lucid,
 emacs23-nox,
 emacs24,
 emacs24-lucid,
 emacs24-nox,
 emacs25,
 emacs25-lucid,
 emacs25-nox,
 apel (<< 10.8+0.20120427-4),
 edb (<< 1.32),
 egg (<< 4.2.0-2),
Description: GNU Emacs editor's shared, architecture independent infrastructure
 GNU Emacs is the extensible self-documenting text editor.
 This package contains the architecture independent infrastructure
 that's shared by emacs-gtk, emacs-lucid, and emacs-nox.

Package: emacs-el
Architecture: all
Depends: emacs-common (= ${source:Version}), ${misc:Depends}
Description: GNU Emacs LISP (.el) files
 GNU Emacs is the extensible self-documenting text editor.
 This package contains the elisp sources for the convenience of users,
 saving space in the main package for small systems.

## emacs 26.1.3

=== debian/changelog ===
emacs (1:26.1.3-deepin1) unstable; urgency=medium

  * Add loongarch support.

 -- yanghaibo <yanghaibo@uniontech.com>  Wed, 22 Feb 2023 13:55:03 +0800

emacs (1:26.1.2-deepin1) unstable; urgency=medium

  * Fix CVE-2022-45939.

 -- yanghaibo <yanghaibo@uniontech.com>  Wed, 22 Feb 2023 10:39:49 +0800

emacs (1:26.1.1-1+dde) stable; urgency=medium

  * add sw64 porting.

 -- Zhang Feilong <zhangfeilong@uniontech.com>  Fri, 19 Jun 2020 15:59:13 +0800

emacs (1:26.1+1-3.2+deb10u2) buster; urgency=medium

  * Don't crash with OpenPGP User IDs with no e-mail address.  Add
    0015-Avoid-elisp-crash-for-OpenPGP-User-IDs-with-no-e-mai.patch to
    address the issue.  Thanks to Daniel Kahn Gillmor for the upstream
    fix, and reminders to include it. (Closes: #919642)

 -- Rob Browning <rlb@defaultvalue.org>  Fri, 22 Jan 2021 19:42:27 -0600

emacs (1:26.1+1-3.2+deb10u1) buster; urgency=high

  * Update the EPLA packaging key (previous key expires 2019-09-23) via
    the upstream commit f16785d361097df9fddfcc0b60ae6f0d92e7e911.  Add the
    old and new keyrings to debian/ and debian/source/include-binaries
    since debian/patches/ can't handle git binary diffs.  Thanks to Stefan
    Monnier for reporting the problem and providing the patch.

 -- Rob Browning <rlb@defaultvalue.org>  Wed, 04 Sep 2019 21:35:24 -0500

=== debian/control ===
--- 
+++ 
@@ -114,20 +114,20 @@
  emacs-gtk (<< 1:25),
  emacs-lucid (<< 1:25),
  emacs-nox (<< 1:25),
- emacs21,
- emacs21-nox,
- emacs22,
- emacs22-gtk,
- emacs22-nox,
- emacs23,
- emacs23-lucid,
- emacs23-nox,
- emacs24,
- emacs24-lucid,
- emacs24-nox,
- emacs25,
- emacs25-lucid,
- emacs25-nox,
+ emacs21 (<< 1:25),
+ emacs21-nox (<< 1:25),
+ emacs22 (<< 1:25),
+ emacs22-gtk (<< 1:25),
+ emacs22-nox (<< 1:25),
+ emacs23 (<< 1:25),
+ emacs23-lucid (<< 1:25),
+ emacs23-nox (<< 1:25),
+ emacs24 (<< 1:25),
+ emacs24-lucid (<< 1:25),
+ emacs24-nox (<< 1:25),
+ emacs25 (<< 1:25),
+ emacs25-lucid (<< 1:25),
+ emacs25-nox (<< 1:25),
  apel (<< 10.8+0.20120427-4),
  edb (<< 1.32),
  egg (<< 4.2.0-2),
@@ -143,3 +143,143 @@
  GNU Emacs is the extensible self-documenting text editor.
  This package contains the elisp sources for the convenience of users,
  saving space in the main package for small systems.
+
+Package: emacs21
+Section: oldlibs
+Architecture: all
+Depends: emacs-gtk (>= 1:25), ${misc:Depends}
+Description: GNU Emacs transitional package to emacs-gtk
+ GNU Emacs is the extensible self-documenting text editor.  This
+ package is a transitional package to ensure that systems with emacs21
+ installed automatically upgrade to the new unversioned emacs-gtk
+ package.
+
+Package: emacs21-nox
+Section: oldlibs
+Architecture: all
+Depends: emacs-nox (>= 1:25), ${misc:Depends}
+Description: GNU Emacs transitional package to emacs-nox
+ GNU Emacs is the extensible self-documenting text editor.  This
+ package is a transitional package to ensure that systems with emacs21
+ installed automatically upgrade to the new unversioned emacs-nox
+ package.
+
+Package: emacs22
+Section: oldlibs
+Architecture: all
+Depends: emacs-gtk (>= 1:25), ${misc:Depends}
+Description: GNU Emacs transitional package to emacs-gtk
+ GNU Emacs is the extensible self-documenting text editor.  This
+ package is a transitional package to ensure that systems with emacs22
+ installed automatically upgrade to the new unversioned emacs-gtk
+ package.
+
+Package: emacs22-gtk
+Section: oldlibs
+Architecture: all
+Depends: emacs-gtk (>= 1:25), ${misc:Depends}
+Description: GNU Emacs transitional package to emacs-gtk
+ GNU Emacs is the extensible self-documenting text editor.  This
+ package is a transitional package to ensure that systems with emacs22
+ installed automatically upgrade to the new unversioned emacs-gtk
+ package.
+
+Package: emacs22-nox
+Section: oldlibs
+Architecture: all
+Depends: emacs-nox (>= 1:25), ${misc:Depends}
+Description: GNU Emacs transitional package to emacs-nox
+ GNU Emacs is the extensible self-documenting text editor.  This
+ package is a transitional package to ensure that systems with emacs22
+ installed automatically upgrade to the new unversioned emacs-nox
+ package.
+
+Package: emacs23
+Section: oldlibs
+Architecture: all
+Depends: emacs-gtk (>= 1:25), ${misc:Depends}
+Description: GNU Emacs transitional package to emacs-gtk
+ GNU Emacs is the extensible self-documenting text editor.  This
+ package is a transitional package to ensure that systems with emacs23
+ installed automatically upgrade to the new unversioned emacs-gtk
+ package.
+
+Package: emacs23-lucid
+Section: oldlibs
+Architecture: all
+Depends: emacs-lucid (>= 1:25), ${misc:Depends}
+Description: GNU Emacs transitional package to emacs-lucid
+ GNU Emacs is the extensible self-documenting text editor.  This
+ package is a transitional package to ensure that systems with emacs23
+ installed automatically upgrade to the new unversioned emacs-lucid
+ package.
+
+Package: emacs23-nox
+Section: oldlibs
+Architecture: all
+Depends: emacs-nox (>= 1:25), ${misc:Depends}
+Description: GNU Emacs transitional package to emacs-nox
+ GNU Emacs is the extensible self-documenting text editor.  This
+ package is a transitional package to ensure that systems with emacs23
+ installed automatically upgrade to the new unversioned emacs-nox
+ package.
+
+Package: emacs24
+Section: oldlibs
+Architecture: all
+Depends: emacs-gtk (>= 1:25), ${misc:Depends}
+Description: GNU Emacs transitional package to emacs-gtk
+ GNU Emacs is the extensible self-documenting text editor.  This
+ package is a transitional package to ensure that systems with emacs24
+ installed automatically upgrade to the new unversioned emacs-gtk
+ package.
+
+Package: emacs24-lucid
+Section: oldlibs
+Architecture: all
+Depends: emacs-lucid (>= 1:25), ${misc:Depends}
+Description: GNU Emacs transitional package to emacs-lucid
+ GNU Emacs is the extensible self-documenting text editor.  This
+ package is a transitional package to ensure that systems with emacs24
+ installed automatically upgrade to the new unversioned emacs-lucid
+ package.
+
+Package: emacs24-nox
+Section: oldlibs
+Architecture: all
+Depends: emacs-nox (>= 1:25), ${misc:Depends}
+Description: GNU Emacs transitional package to emacs-nox
+ GNU Emacs is the extensible self-documenting text editor.  This
+ package is a transitional package to ensure that systems with emacs24
+ installed automatically upgrade to the new unversioned emacs-nox
+ package.
+
+Package: emacs25
+Section: oldlibs
+Architecture: all
+Depends: emacs-gtk (>= 1:25), ${misc:Depends}
+Description: GNU Emacs transitional package to emacs-gtk
+ GNU Emacs is the extensible self-documenting text editor.  This
+ package is a transitional package to ensure that systems with emacs25
+ installed automatically upgrade to the new unversioned emacs-gtk
+ package.
+
+Package: emacs25-lucid
+Section: oldlibs
+Architecture: all
+Depends: emacs-lucid (>= 1:25), ${misc:Depends}
+Description: GNU Emacs transitional package to emacs-lucid
+ GNU Emacs is the extensible self-documenting text editor.  This
+ package is a transitional package to ensure that systems with emacs25
+ installed automatically upgrade to the new unversioned emacs-lucid
+ package.
+
+Package: emacs25-nox
+Section: oldlibs
+Architecture: all
+Depends: emacs-nox (>= 1:25), ${misc:Depends}
+Description: GNU Emacs transitional package to emacs-nox
+ GNU Emacs is the extensible self-documenting text editor.  This
+ package is a transitional package to ensure that systems with emacs25
+ installed automatically upgrade to the new unversioned emacs-nox
+ package.

=== debian/rules ===
--- 
+++ 
@@ -112,9 +112,6 @@
   joblimit := 1
 endif
 
-target := $(DEB_HOST_GNU_TYPE)
-movemail_bin := usr/lib/emacs/$(runtime_ver)/$(target)/movemail
-
 # Info files that are going to show up in the main dir.
 main_dir_info_files := efaq.info
 
@@ -126,7 +123,6 @@
 persistent_autogen_install_files :=
 
 nonpersistent_autogen_install_files := \
-  debian/emacs-bin-common.lintian-overrides \
   debian/emacs-bin-common.postinst \
   debian/emacs-bin-common.prerm \
   debian/emacs-common.README.Debian \
@@ -134,14 +130,11 @@
   debian/emacs-common.prerm \
   debian/emacs-nox.lintian-overrides \
   debian/emacs-nox.postinst \
-  debian/emacs-nox.preinst \
   debian/emacs-nox.prerm \
   debian/emacs-lucid.lintian-overrides \
   debian/emacs-lucid.postinst \
-  debian/emacs-lucid.preinst \
   debian/emacs-lucid.prerm \
   debian/emacs-gtk.lintian-overrides \
-  debian/emacs-gtk.preinst \
   debian/emacs-gtk.postinst \
   debian/emacs-gtk.prerm
 
@@ -204,13 +197,20 @@
     -e "s|\@MENU_VERSION\@|$(menu_ver)|go;" \
     -e "s|\@X_SUPPORT\@|$(xsupport)|go;" \
     -e "s|\@BIN_PRIORITY\@|$(bin_priority)|go;" \
-    -e "s|\@MOVEMAIL_BIN\@|$(movemail_bin)|go;" \
       < $(1) > $(2)
 endef
 
 %:
-	dh $@ --parallel
+	dh $@
 
 check-vars:
 	@echo "src_name: $(src_name)"
 	@echo "upstream_ver: $(upstream_ver)"
+	@echo "debian_ver: $(debian_ver)"
+	@echo "debsrc_ver: $(debsrc_ver)"
+	@echo "debian_rev: $(debian_rev)"
+	@echo "runtime_ver: $(runtime_ver)"
+	@echo "major_ver: $(major_ver)"
+	@echo "minor_ver: $(minor_ver)"
+
+.PHONY: check-autogen
